'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _sandbox = require('./sandbox');

var _sandbox2 = _interopRequireDefault(_sandbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Notebook = function (_React$PureComponent) {
  _inherits(Notebook, _React$PureComponent);

  function Notebook() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Notebook);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Notebook.__proto__ || Object.getPrototypeOf(Notebook)).call.apply(_ref, [this].concat(args))), _this), _this.getLineNumber = function (originalLineNumber) {
      return originalLineNumber + _this.props.initialLineNumber;
    }, _this.updateHeight = function (editorElement, code) {
      editorElement.style.height = (code.split('\n').length + 1) * 18 + 'px';
      editorElement.parentNode.style.height = code.split('\n').length * 18 + 'px';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Notebook, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var moduleRequire = window.require || window.xrequire;

      if (!moduleRequire) {
        throw new Error('Notebook loader is required');
      }

      moduleRequire.config({ paths: { vs: this.props.loaderPath } });
      moduleRequire(['vs/editor/editor.main'], function () {
        var isFocused = _this2.props.isFocused;
        var code = _this2.props.notebookState.content;
        var editorElement = document.createElement('div');

        _this2.notebook.appendChild(editorElement);
        _this2.updateHeight(editorElement, code);
        _this2.editor = monaco.editor.create(editorElement, {
          automaticLayout: true,
          hideCursorInOverviewRuler: true,
          minimap: {
            enabled: false,
            showSlider: false
          },
          contextmenu: false,
          scrollbar: {
            vertical: 'hidden',
            handleMouseWheel: false
          },
          value: code,
          language: 'javascript',
          lineNumbers: 'off' // this.getLineNumber
        });

        var isEmpty = _this2.editor.createContextKey('isEmpty', !code);

        _this2.editor.onDidChangeModelContent(function () {
          var newCode = _this2.editor.getValue();

          _this2.updateHeight(editorElement, newCode);
          _this2.editor.layout();
          isEmpty.set(!newCode);

          _this2.props.onChange(_extends({}, _this2.props.notebookState, { content: newCode }));
        });

        _this2.editor.onDidFocusEditor(function () {
          _this2.props.onFocus();
        });

        _this2.editor.onMouseDown(function () {
          _this2.props.onFocus();
        });

        _this2.editor.onDidBlurEditor(function () {
          _this2.props.onBlur();
        });

        _this2.editor.addCommand(monaco.KeyCode.Backspace, function () {
          _this2.props.onRemove();
        }, 'isEmpty');

        if (isFocused) {
          process.nextTick(function () {
            return _this2.editor.focus();
          });
        }

        _this2.props.sandbox.register(monaco, _this2.props.ramlClientConfig);
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.editor) {
        this.editor.dispose();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          _props$notebookState = _props.notebookState,
          exec = _props$notebookState.exec,
          isLoading = _props$notebookState.isLoading,
          isExecuted = _props$notebookState.isExecuted,
          onExecute = _props.onExecute;


      return _react2.default.createElement(
        'div',
        { className: 'notebook' },
        _react2.default.createElement(
          'div',
          { className: 'editor-container' },
          _react2.default.createElement('div', { ref: function ref(c) {
              _this3.notebook = c;
            }, className: 'editor' }),
          _react2.default.createElement(
            'button',
            { type: 'button', className: 'play' + (isLoading ? ' loading' : ''), onClick: isLoading ? null : onExecute },
            isLoading ? null : _react2.default.createElement(
              'svg',
              { viewBox: '0 0 20 20' },
              _react2.default.createElement('polygon', { points: '8,6 14,10 8,14' }),
              _react2.default.createElement('circle', { cx: '10', cy: '10', r: '9', strokeWidth: '2', fill: 'transparent' })
            ),
            isLoading ? 'Executing ...' : 'Play snippet'
          )
        ),
        exec && exec.result !== undefined ? _react2.default.createElement(
          'div',
          { className: 'success' },
          _react2.default.createElement(
            'div',
            { className: 'block-number' },
            '$' + exec.blockNumber + '='
          ),
          _react2.default.createElement(
            'div',
            { className: 'result' },
            stringify(exec.result)
          )
        ) : null,
        exec && exec.error !== undefined ? _react2.default.createElement(
          'div',
          { className: 'error' },
          _react2.default.createElement(
            'div',
            { className: 'block-number' },
            '$' + exec.blockNumber + '='
          ),
          _react2.default.createElement(
            'div',
            { className: 'result' },
            exec.error.stack
          )
        ) : null,
        exec && isExecuted && exec.error === undefined && exec.result === undefined ? _react2.default.createElement(
          'div',
          { className: 'success' },
          _react2.default.createElement('div', { className: 'block-number' }),
          _react2.default.createElement(
            'div',
            { className: 'result' },
            'Code snippet executed with no results'
          )
        ) : null
      );
    }
  }]);

  return Notebook;
}(_react2.default.PureComponent);

Notebook.propTypes = {
  notebookState: _propTypes2.default.object,
  isFocused: _propTypes2.default.bool,
  initialLineNumber: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  onRemove: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onExecute: _propTypes2.default.func,
  loaderPath: _propTypes2.default.string.isRequired,
  sandbox: _propTypes2.default.object,
  ramlClientConfig: _propTypes2.default.object
};
Notebook.defaultProps = {
  notebookState: { content: '' },
  isFocused: false,
  initialLineNumber: 0,
  onChange: function onChange() {},
  onRemove: function onRemove() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {},
  onExecute: function onExecute() {},
  sandbox: new _sandbox2.default()
};
exports.default = Notebook;


function stringify(object) {
  if (object && object.toDescription) {
    return object.toDescription();
  }
  try {
    return JSON.stringify(object, null, 2);
  } catch (err) {
    return object.toString();
  }
}
//# sourceMappingURL=component.js.map