'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _loader = require('./loader');

var _loader2 = _interopRequireDefault(_loader);

var _ramlClient = require('./ramlClient');

var _ramlClient2 = _interopRequireDefault(_ramlClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sandbox = function () {
  function Sandbox() {
    var _this = this;

    _classCallCheck(this, Sandbox);

    if (typeof document !== 'undefined') {
      this.frame = document.createElement('iframe');
      this.frame.style.display = 'none';
      this.executeWindow = {};
      this.frame.addEventListener('load', function () {
        _this.frame.contentWindow.executeWindow = _this.executeWindow;
      });

      document.body.appendChild(this.frame);
    }
  }

  _createClass(Sandbox, [{
    key: 'execute',
    value: function execute(code, blockNumber) {
      var _this2 = this;

      var promise = Promise.resolve();
      var exec = {
        blockNumber: blockNumber
      };

      try {
        exec.result = this.frame.contentWindow.eval('with(executeWindow){\n' + code + '\n}');
      } catch (error) {
        exec.error = error;
      }

      if (exec.result && exec.result.then && typeof exec.result.then === 'function') {
        promise = exec.result.then(function (value) {
          exec.result = value;
        }).catch(function (error) {
          exec.error = error;
        });
      }

      return promise.then(function () {
        if (blockNumber !== undefined) {
          _this2.executeWindow['$' + blockNumber] = exec.error || exec.result;
        }

        return exec;
      });
    }
  }, {
    key: 'register',
    value: function register(editor, clientConfig) {
      var _this3 = this;

      if (this.isRegistered) {
        return;
      }
      this.isRegistered = true;

      this.executeWindow.API = (0, _ramlClient2.default)(editor, this.executeWindow, clientConfig);
      this.executeWindow.load = function (src, done) {
        return (0, _loader2.default)(_this3, src, done);
      };
    }
  }, {
    key: 'dispose',
    value: function dispose() {
      if (this.frame.parentNode) {
        this.frame.parentNode.removeChild(this.frame);
      }

      this.isDisposed = true;
    }
  }]);

  return Sandbox;
}();

exports.default = Sandbox;
//# sourceMappingURL=index.js.map