'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (editor, contextWindow, ramlClientConfig) {
  var clientConfig = Object.assign({
    oauthCallback: (global.location && global.location.origin) + '/node_modules/raml-client/authentication/oauth.html',
    prompt: function (_prompt) {
      function prompt(_x) {
        return _prompt.apply(this, arguments);
      }

      prompt.toString = function () {
        return _prompt.toString();
      };

      return prompt;
    }(function (prompts) {
      var result = {
        scopes: prompts.scopes
      };

      prompts.keys.forEach(function (key) {
        if (key !== 'scopes') {
          result[key] = prompt(key);
        }
      });

      return Promise.resolve(result);
    }),

    sync: true,
    contextWindow: contextWindow,
    editor: editor
  }, ramlClientConfig);

  return (0, _ramlClient2.default)(clientConfig);
};

var _ramlClient = require('raml-client');

var _ramlClient2 = _interopRequireDefault(_ramlClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=ramlClient.js.map