'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

var _sandbox = require('./sandbox');

var _sandbox2 = _interopRequireDefault(_sandbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StandaloneApp = function (_React$Component) {
  _inherits(StandaloneApp, _React$Component);

  function StandaloneApp(props) {
    _classCallCheck(this, StandaloneApp);

    var _this = _possibleConstructorReturn(this, (StandaloneApp.__proto__ || Object.getPrototypeOf(StandaloneApp)).call(this, props));

    _this.handleChange = function (notebookState) {
      var afterChange = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

      _this.setState({
        notebookState: _extends({}, notebookState, {
          isExecuted: false
        })
      }, function () {
        _this.props.onChange(_this.state.notebookState);
        afterChange(_this.state.notebookState);
      });
    };

    _this.handleExecute = function () {
      var notebookState = _this.state.notebookState;
      var _this$props = _this.props,
          blockNumber = _this$props.blockNumber,
          sandbox = _this$props.sandbox,
          beforeExecute = _this$props.beforeExecute;


      _this.handleChange(_extends({}, notebookState, { isLoading: true }));

      return beforeExecute(notebookState).then(function () {
        return new Promise(function (resolve, reject) {
          process.nextTick(function () {
            sandbox.execute(notebookState.content, blockNumber).then(function (exec) {
              _this.handleChange(_extends({}, notebookState, { exec: exec, isLoading: false }), function (newNotebookState) {
                _this.setState({ notebookState: _extends({}, newNotebookState, { isExecuted: true }) });
              });
            }).then(resolve).catch(reject);
          });
        });
      });
    };

    _this.state = {
      notebookState: {
        content: _this.props.content
      }
    };
    return _this;
  }

  _createClass(StandaloneApp, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          blockNumber = _props.blockNumber,
          loaderPath = _props.loaderPath,
          sandbox = _props.sandbox,
          ramlClientConfig = _props.ramlClientConfig;
      var notebookState = this.state.notebookState;


      return _react2.default.createElement(_component2.default, {
        blockNumber: blockNumber,
        loaderPath: loaderPath,
        notebookState: notebookState,
        onChange: this.handleChange,
        onExecute: this.handleExecute,
        sandbox: sandbox,
        ramlClientConfig: ramlClientConfig
      });
    }
  }]);

  return StandaloneApp;
}(_react2.default.Component);

StandaloneApp.propTypes = {
  content: _propTypes2.default.string,
  blockNumber: _propTypes2.default.number,
  loaderPath: _propTypes2.default.string.isRequired,
  sandbox: _propTypes2.default.object,
  onChange: _propTypes2.default.func,
  beforeExecute: _propTypes2.default.func,
  ramlClientConfig: _propTypes2.default.object
};
StandaloneApp.defaultProps = {
  content: '',
  blockNumber: 0,
  sandbox: new _sandbox2.default(),
  onChange: function onChange() {},
  beforeExecute: function beforeExecute() {
    return Promise.resolve();
  }
};
exports.default = StandaloneApp;
//# sourceMappingURL=standalone.js.map