import createClient from 'raml-client';

export default function (editor, contextWindow, ramlClientConfig) {
  const clientConfig = Object.assign({
    oauthCallback: `${global.location && global.location.origin}/node_modules/raml-client/authentication/oauth.html`,
    prompt(prompts) {
      const result = {
        scopes: prompts.scopes
      };

      prompts.keys.forEach((key) => {
        if (key !== 'scopes') {
          result[key] = prompt(key);
        }
      });

      return Promise.resolve(result);
    },
    sync: true,
    contextWindow,
    editor
  }, ramlClientConfig);

  return createClient(clientConfig);
}
